/*
 * nooks-iwrapper.h -- data structures for iwrappers 
 *
 * Copyright (C) 2001 Mike Swift
 *
 * The source code in this file can be freely used, adapted,
 * and redistributed in source or binary form, so long as an
 * acknowledgment appears in derived source files.  No warranty 
 * is attached; * we cannot take responsibility for errors or 
 * fitness for use.
 */

#ifndef _LINUX_NOOKS_IWRAPPER_H
#define _LINUX_NOOKS_IWRAPPER_H

/* FIXME Cleanup with the not required ops and also add
 * functions which are new..E.g. access_fastpath..Remove vmops asops etc.
 */

struct iwrapper_netdev_operations {
  nook_iwrapper_t hard_header_cache;
  nook_iwrapper_t open;
  nook_iwrapper_t hard_header;
  nook_iwrapper_t init;
  nook_iwrapper_t do_ioctl;
  nook_iwrapper_t hard_header_parse;
  nook_iwrapper_t stop;
  nook_iwrapper_t get_wireless_stats;
  nook_iwrapper_t header_cache_update;
  nook_iwrapper_t uninit;
  nook_iwrapper_t tx_timeout;
  nook_iwrapper_t set_multicast_list;
  nook_iwrapper_t destructor;
  nook_iwrapper_t hard_start_xmit;
  nook_iwrapper_t set_mac_address;
  nook_iwrapper_t neigh_setup;
  nook_iwrapper_t accept_fastpath;
  nook_iwrapper_t rebuild_header;
  nook_iwrapper_t get_stats;
  nook_iwrapper_t set_config;
  nook_iwrapper_t change_mtu;
};

/*
struct iwrapper_usb_operations {
  nook_iwrapper_t probe;
  nooks_iwrapper_t ioctl;
  nooks_iwrapper_t disconnect;
  nooks_iwrapper_t ioctl;
  nooks_iwrapper_t suspend;
  nooks_iwrapper_t resume;
  nooks_iwrapper_t pre_reset;
  nooks_iwrapper_t post_reset;
}; 
*/

struct iwrapper_module_operations {
  nook_iwrapper_t init;
  nook_iwrapper_t exit;
//  nook_iwrapper_t unsafe;
};

struct iwrapper_file_operations {
  nook_iwrapper_t poll;
  nook_iwrapper_t release;
  nook_iwrapper_t mmap;
  nook_iwrapper_t llseek;
  nook_iwrapper_t sendfile;
  nook_iwrapper_t check_flags;
  nook_iwrapper_t write;
  nook_iwrapper_t splice_write;
  nook_iwrapper_t readdir;
  nook_iwrapper_t splice_read;
  nook_iwrapper_t writev;
  nook_iwrapper_t unlocked_ioctl;
  nook_iwrapper_t sendpage;
  nook_iwrapper_t fasync;
  nook_iwrapper_t flush;
  nook_iwrapper_t aio_write;
  nook_iwrapper_t fsync;
  nook_iwrapper_t ioctl;
  nook_iwrapper_t dir_notify;
  nook_iwrapper_t read;
  nook_iwrapper_t readv;
  nook_iwrapper_t aio_fsync;
  nook_iwrapper_t compat_ioctl;
  nook_iwrapper_t lock;
  nook_iwrapper_t aio_read;
  nook_iwrapper_t open;
  nook_iwrapper_t get_unmapped_area;
  nook_iwrapper_t flock;
};

struct iwrapper_actor_operations {
  nook_iwrapper_t read;
};

struct iwrapper_procfs_operations {
  nook_iwrapper_t write_proc;
  nook_iwrapper_t read_proc;
  nook_iwrapper_t get_info;
};

struct iwrapper_pci_operations {
  //nook_iwrapper_t prepare;
  nook_iwrapper_t remove;
  nook_iwrapper_t enable_wake;
  //nook_iwrapper_t save_state;
  //nook_iwrapper_t activate;
  nook_iwrapper_t resume;
  nook_iwrapper_t suspend;
  nook_iwrapper_t shutdown;
  //nook_iwrapper_t deactivate;
  nook_iwrapper_t probe;
};

struct iwrapper_notifier_operations {
  nook_iwrapper_t notifier_call;
};

struct iwrapper_fs_operations {
  nook_iwrapper_t read_super;
};


struct iwrapper_callback_operations {
  nook_iwrapper_t handler;
  nook_iwrapper_t pm_handler;
};


struct iwrapper_timer_operations {
  nook_iwrapper_t handler;
};

struct iwrapper_sysctl_operations {
  nook_iwrapper_t strategy;
  nook_iwrapper_t proc_handler;
};

struct iwrapper_irq_operations {
  nook_iwrapper_t handler;
};


#endif /* _LINUX_NOOKS_IWRAPPER_H */
