/*
 * nooks-nwrappers.c -- empty wrappers to replace iwrappers
 *
 * Copyright (C) 2001 Mike Swift
 *
 * The source code in this file can be freely used, adapted,
 * and redistributed in source or binary form, so long as an
 * acknowledgment appears in derived source files.  No warranty 
 * is attached; * we cannot take responsibility for errors or 
 * fitness for use.
 *
 */

 
#include "nooks-i.h"
#include "nooks-nwrappers.h"
#include <linux/module.h>



/**********************************************************
 *
 * Module operations wrappers
 *
 *********************************************************/

int NOOKS_NWRAPPER(mops_init)(void)
{ 
  return(-EFAULT);
}

void NOOKS_NWRAPPER(mops_exit)(void)
{ 
  return;
}
/*
int NOOKS_NWRAPPER(mops_can_unload)(void)
{ 
  return(-EFAULT);
}
*/
struct module_operations NOOKS_NWRAPPER(mops) = {
  init: NOOKS_NWRAPPER(mops_init),
  exit: NOOKS_NWRAPPER(mops_exit),
  //unsafe: NOOKS_NWRAPPER(mops_unsafe)
};

/**********************************************************
 *
 * ProcFs operations wrappers
 *
 *********************************************************/

int NOOKS_NWRAPPER(procops_read_proc)(char *page, 
			      char **start, 
			      off_t off,
			      int count, 
			      int *eof, 
			      void *data)
{
  return(-EFAULT);
}


int NOOKS_NWRAPPER(procops_write_proc)(struct file *file, 
			       const char *buffer,
			       unsigned long count, 
			       void *data)
{
  return(-EFAULT);
}

int NOOKS_NWRAPPER(procops_get_info)(char * buffer, 
			     char ** start, 
			     off_t off, 
			     int len)
{
  return(-EFAULT);
}

struct procfs_operations NOOKS_NWRAPPER(procops) = {
  read_proc: NOOKS_NWRAPPER(procops_read_proc),
  write_proc: NOOKS_NWRAPPER(procops_write_proc),
  get_info: NOOKS_NWRAPPER(procops_get_info)
};

/**********************************************************
 *
 * net device operations wrappers
 *
 *********************************************************/

int NOOKS_NWRAPPER(netops_init)(struct net_device *dev)
{
  return(-EFAULT);
}

struct net_device_stats * NOOKS_NWRAPPER(netops_get_stats)(struct net_device *dev)
{
  return(NULL);
}

struct iw_statistics * NOOKS_NWRAPPER(netops_get_wireless_stats)(struct net_device *dev)
{
  return(NULL);
}



void NOOKS_NWRAPPER(netops_uninit)(struct net_device *dev)
{
}

void NOOKS_NWRAPPER(netops_destructor)(struct net_device *dev)
{
}

int NOOKS_NWRAPPER(netops_open)(struct net_device *dev)
{
  return(-EFAULT);
}

int NOOKS_NWRAPPER(netops_stop)(struct net_device *dev)
{
  return(-EFAULT);
}

int NOOKS_NWRAPPER(netops_hard_start_xmit) (struct sk_buff *skb,
					    struct net_device *dev)
{
  return(-EFAULT);
}

int NOOKS_NWRAPPER(netops_hard_header) (struct sk_buff *skb,
					struct net_device *dev,
					unsigned short type,
					void *daddr,
					void *saddr,
					unsigned len)
{
  return(-EFAULT);
}

int NOOKS_NWRAPPER(netops_rebuild_header)(struct sk_buff *skb)
{
  return(-EFAULT);
}

void NOOKS_NWRAPPER(netops_set_multicast_list)(struct net_device *dev)
{
}

int NOOKS_NWRAPPER(netops_set_mac_address)(struct net_device *dev,
					   void *addr)
{
  return(-EFAULT);
}

int NOOKS_NWRAPPER(netops_do_ioctl)(struct net_device *dev,
				    struct ifreq *ifr, 
				    int cmd)
{
  return(-EFAULT);
}

int NOOKS_NWRAPPER(netops_set_config)(struct net_device *dev,
				      struct ifmap *map)
{
  return(-EFAULT);
}

int NOOKS_NWRAPPER(netops_hard_header_cache)(struct neighbour *neigh,
					     struct hh_cache *hh)
{
  return(-EFAULT);
}

void NOOKS_NWRAPPER(netops_header_cache_update)(struct hh_cache *hh,
						struct net_device *dev,
						unsigned char *  haddr)
{
}

int NOOKS_NWRAPPER(netops_change_mtu)(struct net_device *dev, int new_mtu)
{
  return(-EFAULT);
}

void NOOKS_NWRAPPER(netops_tx_timeout) (struct net_device *dev)
{
}

int NOOKS_NWRAPPER(netops_hard_header_parse)(struct sk_buff *skb,
					     unsigned char *haddr)
{
  return(-EFAULT);
}

int NOOKS_NWRAPPER(netops_neigh_setup)(struct net_device *dev, 
				       struct neigh_parms * parms)
{
  return(-EFAULT);
}

int NOOKS_NWRAPPER(netops_accept_fastpath)(struct net_device * dev, 
					   struct dst_entry * entry)
{
  return(-EFAULT);
}

int NOOKS_NWRAPPER(e1000_clean)(struct net_device * dev, 
				int * budget)
{
  return (-EFAULT);
}



struct netdev_operations NOOKS_NWRAPPER(netdevops) = {
  init: NOOKS_NWRAPPER(netops_init),
  get_stats:  NOOKS_NWRAPPER(netops_get_stats),
  get_wireless_stats: NOOKS_NWRAPPER(netops_get_wireless_stats),
  uninit: NOOKS_NWRAPPER(netops_uninit),
  destructor: NOOKS_NWRAPPER(netops_destructor),
  open: NOOKS_NWRAPPER(netops_open),
  stop: NOOKS_NWRAPPER(netops_stop),
  hard_start_xmit: NOOKS_NWRAPPER(netops_hard_start_xmit),
  hard_header: NOOKS_NWRAPPER(netops_hard_header),
  rebuild_header: NOOKS_NWRAPPER(netops_rebuild_header),
  set_multicast_list: NOOKS_NWRAPPER(netops_set_multicast_list),
  set_mac_address: NOOKS_NWRAPPER(netops_set_mac_address),
  do_ioctl: NOOKS_NWRAPPER(netops_do_ioctl),
  set_config: NOOKS_NWRAPPER(netops_set_config),
  hard_header_cache: NOOKS_NWRAPPER(netops_hard_header_cache),
  header_cache_update: NOOKS_NWRAPPER(netops_header_cache_update),
  change_mtu: NOOKS_NWRAPPER(netops_change_mtu),
  tx_timeout: NOOKS_NWRAPPER(netops_tx_timeout),
  hard_header_parse: NOOKS_NWRAPPER(netops_hard_header_parse),
  neigh_setup: NOOKS_NWRAPPER(netops_neigh_setup),
  //accept_fastpath: NOOKS_NWRAPPER(netops_accept_fastpath)
  e1000_clean: NOOKS_NWRAPPER(e1000_clean)
};

/**********************************************************
 *
 * irq operations wrappers
 *
 *********************************************************/

void NOOKS_NWRAPPER(irqops_handler)(int irq, 
				    void * dev_id, 
				    struct pt_regs * regs)
{
}

struct irq_operations NOOKS_NWRAPPER(irqops) = {
  handler: NOOKS_NWRAPPER(irqops_handler)
};

/**********************************************************
 *
 * pci operations wrappers
 *
 *********************************************************/

int NOOKS_NWRAPPER(pciops_prepare)(struct pci_dev *dev)
{
  return(-EFAULT);
}

int NOOKS_NWRAPPER(pciops_activate)(struct pci_dev *dev)
{
  return(-EFAULT);
}

int NOOKS_NWRAPPER(pciops_deactivate)(struct pci_dev *dev)
{
  return(-EFAULT);
}

int  NOOKS_NWRAPPER(pciops_probe)(struct pci_dev *dev, 
				  const struct pci_device_id *id)
{
  return(-EFAULT);
}

void NOOKS_NWRAPPER(pciops_remove) (struct pci_dev *dev)
{
}

int  NOOKS_NWRAPPER(pciops_save_state) (struct pci_dev *dev, u32 state)
{
  return(-EFAULT);
}

int  NOOKS_NWRAPPER(pciops_suspend)(struct pci_dev *dev, u32 state)
{
  return(-EFAULT);
}

int  NOOKS_NWRAPPER(pciops_resume) (struct pci_dev *dev)
{
  return(-EFAULT);
}


int  NOOKS_NWRAPPER(pciops_enable_wake) (struct pci_dev *dev, 
					 u32 state, 
					 int enable)
{
  return(-EFAULT);
}

void NOOKS_NWRAPPER(pciops_shutdown) (struct pci_dev *dev)
{
}


struct pci_operations NOOKS_NWRAPPER(pciops) = {
	//prepare: NOOKS_NWRAPPER(pciops_prepare),
	//activate: NOOKS_NWRAPPER(pciops_activate),
	//deactivate: NOOKS_NWRAPPER(pciops_deactivate),
	remove: NOOKS_NWRAPPER(pciops_remove),
	//save_state: NOOKS_NWRAPPER(pciops_save_state),
	shutdown: NOOKS_NWRAPPER(pciops_shutdown),
	suspend: NOOKS_NWRAPPER(pciops_suspend),
	resume: NOOKS_NWRAPPER(pciops_resume),
	enable_wake: NOOKS_NWRAPPER(pciops_enable_wake)
};

/**********************************************************
 *
 * callback operations wrappers
 *
 *********************************************************/

int NOOKS_NWRAPPER(callbackops_handler)(unsigned long arg)
{
  return(-EFAULT);
}

struct callback_operations  NOOKS_NWRAPPER(callbackops) = {
  handler: NOOKS_NWRAPPER(callbackops_handler)
};


/**********************************************************
 *
 * timer operations wrappers
 *
 *********************************************************/

void NOOKS_NWRAPPER(timerops_handler)(unsigned long arg)
{
}

struct timer_operations  NOOKS_NWRAPPER(timerops) = {
  handler: NOOKS_NWRAPPER(timerops_handler)
};



/**********************************************************
 *
 * sysctl operations wrappers
 *
 *********************************************************/


int NOOKS_NWRAPPER(sysctlops_strategy)(ctl_table *ctl, int *name, 
				  int nlen, void *oldval, 
				  size_t *oldlenp, void *newval, 
				  size_t newlen, void **context)
{
  return(-EFAULT);
}

int NOOKS_NWRAPPER(sysctlops_proc_handler)(ctl_table *ctl, int write, 
				   struct file * filp,
				   void *buffer, size_t *lenp)
{
  return(-EFAULT);
}


struct sysctl_operations NOOKS_NWRAPPER(sysctlops) = {
  strategy: NOOKS_NWRAPPER(sysctlops_strategy),
  proc_handler: NOOKS_NWRAPPER(sysctlops_proc_handler)
};


/**********************************************************
 *
 * actor operations wrappers
 *
 *********************************************************/

int 
NOOKS_NWRAPPER(actorops_read)(read_descriptor_t * desc, 
			      struct page * page, 
			      unsigned long offset, 
			      unsigned long size)
{
  return(-EFAULT);
}


struct actor_operations NOOKS_NWRAPPER(actorops) = {
  read: NOOKS_NWRAPPER(actorops_read),
};


