#define NOOKS_IWRAPPER_TYPE_COUNT 21
typedef enum nooks_iwrapper_type {

  actorops_e = 1,
  asops_e,
  blkops_e,
  bdops_e,
  callbackops_e,
  dentryops_e,
  fops_e,
  fsops_e,
  getblockops_e,
  inodeops_e,
  irqops_e,
  mops_e ,
  netops_e,
  notifierops_e,
  pciops_e,
  procops_e,
  superops_e,
  sysctlops_e,
  timerops_e,
  vmops_e,
  last_ops_e
} nooks_iwrapper_type_t, *pnooks_iwrapper_type_t;

typedef union nook_operations {
  struct actor_operations actorops;
  struct address_space_operations asops;
  //struct blk_operations blkops;
  struct block_device_operations bdops;
  struct callback_operations callbackops;
  struct dentry_operations dentryops;
  struct file_operations fops;
  struct fs_operations fsops;
  //struct getblock_operations getblockops;
  struct inode_operations inodeops;
  struct irq_operations irqops;
  struct module_operations mops;
  struct netdev_operations netops;
  struct notifier_operations notifierops;
  struct pci_operations pciops;
  struct procfs_operations procops;
  struct super_operations superops;
  struct sysctl_operations sysctlops;
  struct timer_operations timerops;
  struct vm_operations_struct vmops;
} nook_operations_t;

typedef union nook_iwrapper_operations {
  void * dummy_ops;
  struct iwrapper_actor_operations * actorops;
  struct iwrapper_address_space_operations * asops;
  //struct iwrapper_blk_operations * blkops;
  struct iwrapper_block_device_operations * bdops;
  struct iwrapper_callback_operations * callbackops;
  struct iwrapper_dentry_operations * dentryops;
  struct iwrapper_file_operations * fops;
  struct iwrapper_fs_operations * fsops;
  //struct iwrapper_getblock_operations * getblockops;
  struct iwrapper_inode_operations * inodeops;
  struct iwrapper_irq_operations * irqops;
  struct iwrapper_module_operations * mops;
  struct iwrapper_netdev_operations * netops;
  struct iwrapper_notifier_operations * notifierops;
  struct iwrapper_pci_operations * pciops;
  struct iwrapper_procfs_operations * procops;
  struct iwrapper_super_operations * superops;
  struct iwrapper_sysctl_operations * sysctlops;
  struct iwrapper_timer_operations * timerops;
  struct iwrapper_vm_operations_struct * vmops;
} nook_iwrapper_operations_t;

