void
nooks_iwrapper_copy_blkdev_ops(
		struct block_device_operations * driver_operations, 
		struct block_device_operations * wrapper_operations,
		struct iwrapper_block_device_operations * iwrapper_operations,
		struct block_device_operations * system_operations)
{

#define IWRAPPER_COPY_BLKDEVOPS(_d_, _w_,  _i_, _s_, _f_) \
  do { \
  if ((_d_)->_f_ != NULL) { \
    (_w_)->_f_ = (_d_)->_f_; \
    (_s_)->_f_ = (void*)((_i_)->_f_.iwrapper); \
  } else { \
    (_w_)->_f_ = NULL; \
    (_s_)->_f_ = NULL; \
  }  } while (0)  

  NOOKS_ENTER();

//  IWRAPPER_COPY_BLKDEVOPS(driver_operations, wrapper_operations, 
//		     iwrapper_operations, system_operations, owner);
  system_operations->owner = driver_operations->owner;
  IWRAPPER_COPY_BLKDEVOPS(driver_operations, wrapper_operations, 
		     iwrapper_operations, system_operations, open);
  IWRAPPER_COPY_BLKDEVOPS(driver_operations, wrapper_operations, 
		     iwrapper_operations, system_operations, release);
  IWRAPPER_COPY_BLKDEVOPS(driver_operations, wrapper_operations, 
		     iwrapper_operations, system_operations, ioctl);
  IWRAPPER_COPY_BLKDEVOPS(driver_operations, wrapper_operations, 
		    iwrapper_operations, system_operations, check_media_change);
  IWRAPPER_COPY_BLKDEVOPS(driver_operations, wrapper_operations, 
		     iwrapper_operations, system_operations, revalidate);
  NOOKS_EXIT();
}

void
nooks_iwrapper_copy_bdops( 
		struct block_device_operations * driver_operations, 
		struct block_device_operations * wrapper_operations,
		struct iwrapper_block_device_operations * iwrapper_operations,
		struct block_device_operations * system_operations)

{

#define IWRAPPER_COPY_FOPS(_d_, _w_,  _i_, _s_, _f_) \
  do { \
  if ((_d_)->_f_ != NULL) { \
    (_w_)->_f_ = (_d_)->_f_; \
    (_s_)->_f_ = (void*)((_i_)->_f_.iwrapper); \
  } else { \
    (_w_)->_f_ = NULL; \
    (_s_)->_f_ = NULL; \
  }  } while (0)  

  NOOKS_ENTER();
  
//  IWRAPPER_COPY_BLKDEVOPS(driver_operations, wrapper_operations, 
//		     iwrapper_operations, system_operations, owner);
  
  system_operations->owner = driver_operations->owner;
  
  IWRAPPER_COPY_BLKDEVOPS(driver_operations, wrapper_operations, 
		     iwrapper_operations, system_operations, open);
  IWRAPPER_COPY_BLKDEVOPS(driver_operations, wrapper_operations, 
		     iwrapper_operations, system_operations, release);
  IWRAPPER_COPY_BLKDEVOPS(driver_operations, wrapper_operations, 
		     iwrapper_operations, system_operations, ioctl);
  IWRAPPER_COPY_BLKDEVOPS(driver_operations, wrapper_operations, 
		    iwrapper_operations, system_operations, check_media_change);
  IWRAPPER_COPY_BLKDEVOPS(driver_operations, wrapper_operations, 
		     iwrapper_operations, system_operations, revalidate);
  
  NOOKS_EXIT();
}

void
nooks_iwrapper_copy_blkops( void (*request_fn)(request_queue_t *),
		struct blk_operations * wrapper_operations,
		struct iwrapper_blk_operations * iwrapper_operations,
		struct blk_operations * system_operations)

{
#define IWRAPPER_COPY_BLKOPS(_d_, _w_,  _i_, _s_, _f_) \
  do { \
  if ((_d_) != NULL) { \
    (_w_)->_f_ = (_d_); \
    (_s_)->_f_ = (void*)((_i_)->_f_.iwrapper); \
  } else { \
    (_w_)->_f_ = NULL; \
    (_s_)->_f_ = NULL; \
  }  } while (0)  

  NOOKS_ENTER();

  IWRAPPER_COPY_BLKOPS(request_fn, wrapper_operations, 
			 iwrapper_operations, system_operations, request_fn);
  

  NOOKS_EXIT();
  
 
}
