/*nooks-ksyms.c -- exported symbols for wrappers od system functions
 *
 * Copyright (C) 2001 Mike Swift
 *
 * The source code in this file can be freely used, adapted,
 * and redistributed in source or binary form, so long as an
 * acknowledgment appears in derived source files.  
 * No warranty is attached;
 * we cannot take responsibility for errors or fitness for use.
 *
 */

#include "nooks-i.h"
#include "nooks-wrappers.h"
#ifdef __GENKSYMS__
#define NOOKS_EXPORT_SYMBOL(_x_) EXPORT_SYMBOL(nooks_w_ ## _x_)
#define NOOKS_EXPORT_SYMBOL_NOVERS(_x_) EXPORT_SYMBOL_NOVERS(nooks_w_ ## _x_)
#else // __GENKSYMS__
#define NOOKS_EXPORT_SYMBOL(_x_) EXPORT_SYMBOL(nooks_w_ ## _x_)
#define NOOKS_EXPORT_SYMBOL_NOVERS(_x_) EXPORT_SYMBOL_NOVERS(nooks_w_ ## _x_)
#endif // __GENKSYMS__

MODULE_AUTHOR("Michael Swift, Asim Kadav");
MODULE_LICENSE("GPL");



/* All functions pertinent to the e1000 driver. */
NOOKS_EXPORT_SYMBOL(alloc_etherdev);
NOOKS_EXPORT_SYMBOL(__alloc_pages);
NOOKS_EXPORT_SYMBOL(__alloc_skb);
NOOKS_EXPORT_SYMBOL(capable);
NOOKS_EXPORT_SYMBOL(__const_udelay);
//NOOKS_EXPORT_SYMBOL(contig_page_data);  FIXME
NOOKS_EXPORT_SYMBOL(del_timer_sync);
NOOKS_EXPORT_SYMBOL(dev_close);
NOOKS_EXPORT_SYMBOL(dev_kfree_skb_any);
NOOKS_EXPORT_SYMBOL(dev_open);
NOOKS_EXPORT_SYMBOL(disable_irq);
NOOKS_EXPORT_SYMBOL(dma_alloc_coherent);
NOOKS_EXPORT_SYMBOL(dma_free_coherent);
NOOKS_EXPORT_SYMBOL(dma_map_page);
NOOKS_EXPORT_SYMBOL(dma_map_single);
NOOKS_EXPORT_SYMBOL(dma_sync_single_for_cpu);
NOOKS_EXPORT_SYMBOL(dma_sync_single_for_device);
NOOKS_EXPORT_SYMBOL(dma_unmap_page);
NOOKS_EXPORT_SYMBOL(dma_unmap_single);
NOOKS_EXPORT_SYMBOL(dump_stack);
NOOKS_EXPORT_SYMBOL(enable_irq);
NOOKS_EXPORT_SYMBOL(ethtool_op_get_link);
NOOKS_EXPORT_SYMBOL(ethtool_op_get_perm_addr);
NOOKS_EXPORT_SYMBOL(ethtool_op_get_sg);
NOOKS_EXPORT_SYMBOL(ethtool_op_get_tso);
NOOKS_EXPORT_SYMBOL(ethtool_op_set_sg);
NOOKS_EXPORT_SYMBOL(eth_type_trans);
NOOKS_EXPORT_SYMBOL(flush_scheduled_work);
NOOKS_EXPORT_SYMBOL(free_irq);
NOOKS_EXPORT_SYMBOL(free_netdev);
NOOKS_EXPORT_SYMBOL(init_timer);
NOOKS_EXPORT_SYMBOL(__ioremap);
NOOKS_EXPORT_SYMBOL(iounmap);
NOOKS_EXPORT_SYMBOL(jiffies);
NOOKS_EXPORT_SYMBOL(kfree);
NOOKS_EXPORT_SYMBOL(kfree_skb);
NOOKS_EXPORT_SYMBOL(__kmalloc);
NOOKS_EXPORT_SYMBOL(kmap_atomic);
NOOKS_EXPORT_SYMBOL(kunmap_atomic);
NOOKS_EXPORT_SYMBOL(memcpy);
NOOKS_EXPORT_SYMBOL(mod_timer);
NOOKS_EXPORT_SYMBOL(msleep);
NOOKS_EXPORT_SYMBOL(msleep_interruptible);
NOOKS_EXPORT_SYMBOL(__netdev_alloc_skb);
NOOKS_EXPORT_SYMBOL(netif_carrier_off);
NOOKS_EXPORT_SYMBOL(netif_carrier_on);
NOOKS_EXPORT_SYMBOL(netif_device_attach);
NOOKS_EXPORT_SYMBOL(netif_device_detach);
NOOKS_EXPORT_SYMBOL(netif_receive_skb);
NOOKS_EXPORT_SYMBOL(__netif_rx_schedule);
NOOKS_EXPORT_SYMBOL(__netif_schedule);
NOOKS_EXPORT_SYMBOL(netpoll_trap);
NOOKS_EXPORT_SYMBOL(param_array_get);
NOOKS_EXPORT_SYMBOL(param_array_set);
NOOKS_EXPORT_SYMBOL(param_get_int);
NOOKS_EXPORT_SYMBOL(param_set_int);
NOOKS_EXPORT_SYMBOL(pci_bus_read_config_byte);
NOOKS_EXPORT_SYMBOL(pci_bus_read_config_dword);
NOOKS_EXPORT_SYMBOL(pci_bus_read_config_word);
NOOKS_EXPORT_SYMBOL(pci_bus_write_config_dword);
NOOKS_EXPORT_SYMBOL(pci_bus_write_config_word);
NOOKS_EXPORT_SYMBOL(pci_choose_state);
NOOKS_EXPORT_SYMBOL(pci_clear_mwi);
NOOKS_EXPORT_SYMBOL(pci_disable_device);
NOOKS_EXPORT_SYMBOL(pci_enable_device);
NOOKS_EXPORT_SYMBOL(pci_enable_wake);
NOOKS_EXPORT_SYMBOL(__pci_register_driver);
NOOKS_EXPORT_SYMBOL(pci_release_regions);
NOOKS_EXPORT_SYMBOL(pci_request_regions);
NOOKS_EXPORT_SYMBOL(pci_set_consistent_dma_mask);
NOOKS_EXPORT_SYMBOL(pci_set_dma_mask);
NOOKS_EXPORT_SYMBOL(pci_set_master);
NOOKS_EXPORT_SYMBOL(pci_set_mwi);
NOOKS_EXPORT_SYMBOL(pci_set_power_state);
NOOKS_EXPORT_SYMBOL(pci_unregister_driver);
NOOKS_EXPORT_SYMBOL(__per_cpu_offset);
//NOOKS_EXPORT_SYMBOL(per_cpu__softnet_data);
NOOKS_EXPORT_SYMBOL(printk);
NOOKS_EXPORT_SYMBOL(pskb_expand_head);
NOOKS_EXPORT_SYMBOL(__pskb_pull_tail);
NOOKS_EXPORT_SYMBOL(___pskb_trim);
NOOKS_EXPORT_SYMBOL(put_page);
NOOKS_EXPORT_SYMBOL(raise_softirq_irqoff);
NOOKS_EXPORT_SYMBOL(register_netdev);
NOOKS_EXPORT_SYMBOL(request_irq);
NOOKS_EXPORT_SYMBOL(schedule_timeout_interruptible);
NOOKS_EXPORT_SYMBOL(schedule_work);
NOOKS_EXPORT_SYMBOL(skb_over_panic);
NOOKS_EXPORT_SYMBOL(_spin_lock);
NOOKS_EXPORT_SYMBOL(_spin_lock_irqsave);
NOOKS_EXPORT_SYMBOL(_spin_trylock);
NOOKS_EXPORT_SYMBOL(_spin_unlock_irqrestore);
NOOKS_EXPORT_SYMBOL(sprintf);
NOOKS_EXPORT_SYMBOL(synchronize_irq);
NOOKS_EXPORT_SYMBOL(__udelay);
NOOKS_EXPORT_SYMBOL(unregister_netdev);
NOOKS_EXPORT_SYMBOL(vfree);
NOOKS_EXPORT_SYMBOL(vmalloc);
NOOKS_EXPORT_SYMBOL(ether_setup);
NOOKS_EXPORT_SYMBOL(kmem_cache_alloc);
NOOKS_EXPORT_SYMBOL(alloc_netdev);
NOOKS_EXPORT_SYMBOL(netif_rx);
