 /*
    * nooks-swrappers.c -- wrappers for system functions
    *
    * Copyright (C) 2003 Mike Swift
    *
    * The source code in this file can be freely used, adapted,
    * and redistributed in source or binary form, so long as an
    * acknowledgment appears in derived source files.  
    * No warranty is attached;
    * we cannot take responsibility for errors or fitness for use.
    *
  */


#include "nooks-i.h"
#include "nooks-wrappers.h"
#include "nooks-swrappers.h"
#include "nooks-iwrappers.h"

#ifdef CONFIG_NOOKS_SHADOW

#include "nooks-swrap-c-gen.h"


void NOOKS_SWRAPPER(__down)(struct semaphore *sem)
{

	__down(sem);
}


int NOOKS_SWRAPPER(__down_interruptible)(struct semaphore *sem)
{
	int result;


	result = __down_interruptible(sem);

	return (result);
}

void NOOKS_SWRAPPER(__up)(struct semaphore *sem)
{
	__up(sem);

}


int NOOKS_SWRAPPER(nooks_get_user_1)(u8 * ptr, int *val)
{
	return (get_user(*val, ptr));
}

int NOOKS_SWRAPPER(nooks_get_user_2)(u16 * ptr, int *val)
{
	return (get_user(*val, ptr));
}

int NOOKS_SWRAPPER(nooks_get_user_4)(u32 * ptr, int *val)
{
	return (get_user(*val, ptr));
}

signed long NOOKS_SWRAPPER(schedule_timeout)(signed long timeout)
{
	return (signed long)(schedule_timeout(timeout));
}

void NOOKS_SWRAPPER(msleep)(unsigned int msecs)
{
	return (msleep(msecs));
}

void NOOKS_SWRAPPER(msleep_interruptible)(msecs)
{
	return msleep_interruptible(msecs);
}

int NOOKS_SWRAPPER(del_timer)(struct timer_list *timer)
{
	return del_timer(timer);
}

void NOOKS_SWRAPPER(add_timer)(struct timer_list *timer)
{
	return add_timer(timer);
}

#if 0
void NOOKS_SWRAPPER(schedule)(void)
{
#ifdef CONFIG_KGDB_THREAD
	kern_schedule();
#else
	do_schedule();
#endif
}
#endif
/*
void NOOKS_SWRAPPER(ll_rw_block)(int arg0, int arg1, struct buffer_head * bh[])
{
  ll_rw_block(arg0, arg1, bh);
  return;
}
*/
#endif // CONFIG_NOOKS_SHADOW
