#ifndef NOOKS_SWRAPPERS_H
#define NOOKS_SWRAPPERS_H


#ifdef CONFIG_NOOKS_SHADOW
#define NOOKS_SWRAPPER(_x_) nooks_s_ ## _x_

void NOOKS_SWRAPPER(__down)(struct semaphore *sem);
int NOOKS_SWRAPPER(__down_interruptible)(struct semaphore *sem);

void NOOKS_SWRAPPER(__up)(struct semaphore *sem);

int NOOKS_SWRAPPER(request_nooks_irq)(unsigned int irq, 
				      void (*handler)(int, void *, struct pt_regs *),
				      unsigned long irqflags, 
				      const char * devname,
				      void *dev_id);

int NOOKS_SWRAPPER(nooks_get_user_1)(u8 * ptr, int *val);
int NOOKS_SWRAPPER(nooks_get_user_2)(u16 * ptr, int *val);
int NOOKS_SWRAPPER(nooks_get_user_4)(u32 * ptr, int *val);
void NOOKS_SWRAPPER(schedule)(void);
//extern void NOOKS_SWRAPPER(ll_rw_block)(int arg0, int arg1, struct buffer_head * bh[]);

#include "nooks-swrap-h-gen.h"


#else
#define nooks_get_user_1(_ptr_, _val_) get_user(*(_val_),(_ptr_))
#define nooks_get_user_2(_ptr_, _val_) get_user(*(_val_),(_ptr_))
#define nooks_get_user_4(_ptr_, _val_) get_user(*(_val_),(_ptr_))

#define NOOKS_SWRAPPER(_x_) _x_
#endif // CONFIG_NOOKS_SHADOW

#endif //NOOKS_SWRAPPERS_H
