#ifndef _LINUX_NOOKS_WORKERS_H
#define _LINUX_NOOKS_WORKERS_H

/**********************************************************
 *
 * This file declares functions for deferred work processing
 * as in when a request made by a driver
 * is deferred until it completes execution.
 *
 *********************************************************/

#define DECLARE_WORKER(_x_) \
int nooks_handler_## _x_(void * data1, void * data2, void * data3)

DECLARE_WORKER(kfree);
DECLARE_WORKER(add_timer);
DECLARE_WORKER(del_timer);
DECLARE_WORKER(mod_timer);
DECLARE_WORKER(netif_rx);
DECLARE_WORKER(enter_netdev);
DECLARE_WORKER(exit_netdev);
DECLARE_WORKER(proc_entry);
DECLARE_WORKER(tasklet_schedule);
DECLARE_WORKER(tasklet_enable);
DECLARE_WORKER(tasklet_disable);
DECLARE_WORKER(dev_kfree_skb_irq);
DECLARE_WORKER(init_etherdev);
DECLARE_WORKER(enter_listen_sock);
DECLARE_WORKER(add_wait);
DECLARE_WORKER(remove_wait);
DECLARE_WORKER(pm_register);


#endif // NOOKS_WORKERS_H
