int *NOOKS_WRAPPER(max_readahead)[MAX_BLKDEV];
int  NOOKS_WRAPPER(max_readahead_num)[MAX_BLKDEV];
int *NOOKS_WRAPPER(max_sectors)[MAX_BLKDEV];
int  NOOKS_WRAPPER(vm_max_readahead);

struct drive_info_struct NOOKS_WRAPPER(drive_info);
struct gendisk *g_disk=NULL;

//Test Function
void NOOKS_KWRAPPER(myfree_irq)(unsigned int irq, void *dev_id)
{
	NOOKS_KWRAPPER_ENTER();

	free_irq(irq, dev_id);

	NOOKS_KWRAPPER_EXIT();
}


//Test Function
void nooks_w_myfree_irq(unsigned int irq, void *dev_id)
{
	
	NOOKS_WRAPPER_ENTER();

	NOOKS_KERNEL_CALL2(nooks_k_myfree_irq, irq, dev_id);

	NOOKS_WRAPPER_EXIT();

}

/* struct proc_dir_entry *NOOKS_KWRAPPER(proc_mkdir)(const char *name, struct proc_dir_entry *parent, struct proc_dir_entry *nook_entry)
{
	struct proc_dir_entry *kern_entry = NULL;
	struct proc_dir_entry *kern_parent = NULL;
	char *kern_name = NULL;
	pnook_t nook = GET_CURRENT_NOOK();
	int result = 0;

	NOOKS_KWRAPPER_ENTER();

	result = nooks_get_driver_string(name, &kern_name);
	if (result < 0) {
		goto Cleanup;
	}
	
	//
	// Find the kernel version of the entry
	//

	if (parent == NULL) {
		kern_parent = NULL;
	} else if (parent == nooks_w_proc_net) {
		kern_parent = proc_net;
	} else if (nooks_find_resource_elem(nook,
					    proc_entry_e,
					    parent,
					    (void **) &kern_parent) < 0) {
		PERROR("Failed to find proc_entry parent for %p\n",
		       parent);
		result = -ENOENT;
		goto Cleanup;
	}

	kern_entry = proc_mkdir(kern_name, kern_parent);

	if (kern_entry == NULL) {
		result = -ENOMEM;
		goto Cleanup;
	}

	result =
	    nooks_memcpy_out(nook_entry, kern_entry,
			     sizeof(struct proc_dir_entry));

	if (result < 0) {
		goto Cleanup;
	}
	//
	// Register a callback so that we can copy back the data
	//

	result =
	    nooks_add_resource_elem(nook, proc_entry_e, nook_entry,
				    kern_entry);
	if (result < 0) {
		goto Cleanup;
	}


      Cleanup:

	if (result < 0) {

		nooks_del_resource_elem(nook, proc_entry_e, nook_entry,
					NULL);

	}
	if (kern_name != NULL) {
		nooks_free_driver_string(kern_name);
	}
	NOOKS_KWRAPPER_EXIT();
	return (kern_entry);


}

struct proc_dir_entry *nooks_w_proc_mkdir(const char *name, struct proc_dir_entry *parent)
{
	struct proc_dir_entry *kern_entry = NULL;
	struct proc_dir_entry *nook_entry = NULL;

	NOOKS_WRAPPER_ENTER();

	nook_entry =
	    (struct proc_dir_entry *)
	    nooks_w_kmalloc(sizeof(struct proc_dir_entry), GFP_KERNEL);
	
	if (nook_entry == NULL) {
		goto Cleanup;
	}

	kern_entry = (struct proc_dir_entry *)
	    NOOKS_KERNEL_CALL3(nooks_k_proc_mkdir,
			       name, parent, nook_entry);

	if (kern_entry != NULL) {
		pnook_t nook = GET_CURRENT_NOOK();
		pnooks_work_item_t item;
		item = nooks_add_work_item(nook,
					   nook,
					   kern_entry,
					   nook_entry,
					   nooks_handler_proc_entry);
		if (item != NULL) {

			//
			// Only call this on the return from this function
			//

			item->flags |= NOOKS_WORK_FLAG_RETURN;
		} else {

			nooks_w_remove_proc_entry(name, parent);
			kern_entry = NULL;
			goto Cleanup;
		}
	}

      Cleanup:

	if (kern_entry == NULL) {
		
		if(nook_entry!=NULL)
		{
			nooks_w_kfree(nook_entry);
			nook_entry = NULL;
		}
	}

	NOOKS_WRAPPER_EXIT();
	return (nook_entry);


}*/



void NOOKS_KWRAPPER(del_gendisk)(struct gendisk *nook_gp)
{
	
	int major, result, result2;
	pnook_t nook = GET_CURRENT_NOOK();
	struct gendisk *gp;	

	NOOKS_KWRAPPER_ENTER();

	result2 = nooks_del_resource_elem(nook, gendisk_e, nook_gp, 
						(void **) &gp);

	g_disk=NULL;	

	if(result2<0)
		goto Cleanup;

	/****Free max_readahead structure allocated earlier*****/

	major=gp->major;
 
	result=nooks_del_resource_elem(		nook,
						sector_info_e,
					   	max_sectors[major],
					    	NULL);

	if(result<0)
		PERROR("max_sectors already released!\n");
	else
		nooks_kfree(max_sectors[major]);
	

	result=nooks_del_resource_elem(		nook,
						sector_info_e,
					   	max_readahead[major],
					    	NULL);

	if(result<0)
		PERROR("max_readahead already released!\n");
	else
		nooks_kfree(max_readahead[major]);
	
	result=nooks_del_resource_elem(		nook,
						sector_info_e,
					   	blksize_size[major],
					    	NULL);

	if(result<0)
		PERROR("blksize_size already released!\n");
	else	
		nooks_kfree(blksize_size[major]);
	
	
	/********************************************************/

	printk("Deleting gendisk... 0\n");

	//Paranoid check
	if (result2 >= 0) {
		
		printk("Deleting gendisk... 1\n");
		NOOKS_SWRAPPER(del_gendisk)(gp);

		printk("Deleting gendisk... 2\n");
		//if(gp->de_arr)
		//	nooks_kfree(gp->de_arr);	

		printk("Deleting gendisk... 3\n");
		//if(gp->flags)
		//	nooks_kfree(gp->flags);
	
		printk("Freeing gendisk->sizes\n");	
		nooks_kfree(gp->sizes);
		//nooks_kfree(gp->part);
		printk("Freeing gendisk %d\n",gp->major);	
		nooks_kfree(gp);

	} else {
		PERROR ("Failed to find gendisk %p for nook %p for del_gendisk\n", data1, nook);
		return ;
	}

	printk("Exitting del_gendisk...\n");

	Cleanup:

	NOOKS_KWRAPPER_EXIT();
	return ;


} 

void nooks_w_del_gendisk(struct gendisk *nook_gp)
{

	NOOKS_WRAPPER_ENTER();

	NOOKS_KERNEL_CALL1(nooks_k_del_gendisk, nook_gp);

	NOOKS_WRAPPER_EXIT();


}

struct proc_dir_entry *NOOKS_KWRAPPER(proc_symlink)(const char *name, struct proc_dir_entry *parent,const char *dest, struct proc_dir_entry *nook_entry)
{
	
	struct proc_dir_entry *kern_entry = NULL;
	struct proc_dir_entry *kern_parent = NULL;
	char *kern_name = NULL;
	char *kern_name2 = NULL;
	pnook_t nook = GET_CURRENT_NOOK();
	int result = 0;

	NOOKS_KWRAPPER_ENTER();

	result = nooks_get_driver_string(name, &kern_name);
	if (result < 0) {
		goto Cleanup;
	}
	
	result = nooks_get_driver_string(dest, &kern_name2);
	if (result < 0) {
		goto Cleanup;
	}
	//
	// Find the kernel version of the entry
	//

	if (parent == NULL) {
		kern_parent = NULL;
	} else if (parent == nooks_w_proc_net) {
		kern_parent = proc_net;
	} else if (nooks_find_resource_elem(nook,
					    proc_entry_e,
					    parent,
					    (void **) &kern_parent) < 0) {
		PERROR("Failed to find proc_entry parent for %p\n",
		       parent);
		result = -ENOENT;
		goto Cleanup;
	}

	kern_entry = NOOKS_SWRAPPER(proc_symlink)(	kern_name, 
							kern_parent, 
							kern_name2);

	if (kern_entry == NULL) {
		result = -ENOMEM;
		goto Cleanup;
	}

	result =
	    nooks_memcpy_out(nook_entry, kern_entry,
			     sizeof(struct proc_dir_entry));

	if (result < 0) {
		goto Cleanup;
	}
	//
	// Register a callback so that we can copy back the data
	//

	result =
	    nooks_add_resource_elem(nook, proc_entry_e, nook_entry,
				    kern_entry);
	if (result < 0) {
		goto Cleanup;
	}


      Cleanup:

	if (result < 0) {

		nooks_del_resource_elem(nook, proc_entry_e, nook_entry,
					NULL);

	}
	if (kern_name != NULL) {
		nooks_free_driver_string(kern_name);
	}
	if (kern_name2 != NULL) {
		nooks_free_driver_string(kern_name2);
	}
	NOOKS_KWRAPPER_EXIT();
	return (kern_entry);


}


struct proc_dir_entry *nooks_w_proc_symlink(const char *name, struct proc_dir_entry *parent,const char *dest)
{
	struct proc_dir_entry *kern_entry = NULL;
	struct proc_dir_entry *nook_entry = NULL;

	NOOKS_WRAPPER_ENTER();

	nook_entry =
	    (struct proc_dir_entry *)
	    nooks_w_kmalloc(sizeof(struct proc_dir_entry), GFP_KERNEL);
	if (nook_entry == NULL) {
		goto Cleanup;
	}

	kern_entry = (struct proc_dir_entry *) 
	NOOKS_KERNEL_CALL4(nooks_k_proc_symlink,name, parent, dest, nook_entry);

	if (kern_entry != NULL) {
		pnook_t nook = GET_CURRENT_NOOK();
		pnooks_work_item_t item;
		item = nooks_add_work_item(nook,
					   nook,
					   kern_entry,
					   nook_entry,
					   nooks_handler_proc_entry);
		if (item != NULL) {

			//
			// Only call this on the return from this function
			//

			item->flags |= NOOKS_WORK_FLAG_RETURN;
		} else {

			nooks_w_remove_proc_entry(name, parent);
			kern_entry = NULL;
			goto Cleanup;
		}
	}

      Cleanup:

	if (kern_entry == NULL) {
		nooks_w_kfree(nook_entry);
		nook_entry = NULL;
	}

	NOOKS_WRAPPER_EXIT();
	return (nook_entry);



}




void NOOKS_KWRAPPER(wait_for_completion)(struct completion *nook_wait)
{
	
	int result = 0;
	struct completion *wait;
	NOOKS_KWRAPPER_ENTER();

	/* copy parameters from driver to kernel */

	wait = nooks_kmalloc(sizeof(struct completion), NOOKS_MEM_FLAGS);
	if (wait == NULL) {
		result = -ENOMEM;
		NOOKS_FAULT(enomem);
		goto clean;
	}

	result = nooks_memcpy(wait, nook_wait, sizeof(struct completion));
	
	if (result < 0) {
		/* FIXME parameter fault */
		NOOKS_FAULT(parameter);
		goto clean;
	}
	
	NOOKS_SWRAPPER(wait_for_completion)((struct completion *) wait);

clean:
	if(wait!=NULL)
		nooks_kfree(wait);
	
	NOOKS_KWRAPPER_EXIT();
	return;

}

void nooks_w_wait_for_completion(struct completion *nook_wait)
{

	NOOKS_WRAPPER_ENTER();

	NOOKS_KERNEL_CALL1(nooks_k_wait_for_completion, nook_wait);

	NOOKS_WRAPPER_EXIT();

}





void NOOKS_KWRAPPER(grok_partitions)(struct gendisk *nook_disk, int drive, unsigned minors, long size)
{
	int result, counter;
	int first_minor;
	int end_minor;	
	struct gendisk *gp;
	pnook_t nook = GET_CURRENT_NOOK();
	int major;
	

	printk("Inside grok partitions 1\n");	

	NOOKS_KWRAPPER_ENTER();

	result = nooks_find_resource_elem(nook, gendisk_e, nook_disk, (void **) &gp);
	
	if (result >= 0) {
		first_minor=drive<<nook_disk->minor_shift;
		end_minor=first_minor + nook_disk->max_p;	
	}
	else
	{
		PERROR ("Failed to find gendisk %p for nook %p for grok_partitions\n", data1, nook);
		goto Cleanup;
	}


	/*************************/
	major=gp->major;	

	memcpy(&blk_dev[major], &nooks_w_blk_dev[major], 
		sizeof(struct blk_dev_struct));	

	memcpy(&blksize_size[major], &nooks_w_blksize_size[major], 
		sizeof(int)*nooks_w_max_readahead_num[major]);	
  
  	memcpy(&max_readahead[major], &nooks_w_max_readahead[major], 
		sizeof(int)*nooks_w_max_readahead_num[major]);	

  	memcpy(&max_sectors[major], &nooks_w_max_sectors[major], 
		sizeof(int)*nooks_w_max_readahead_num[major]);	

	/*************************/


	printk("Inside grok partitions 2\n");	
	if (result >= 0) {
		NOOKS_SWRAPPER(grok_partitions)(gp, drive, minors, size);
		printk("Inside grok partitions 3n");	

	} else {
		PERROR ("Failed to find gendisk %p for nook %p for grok_partitions\n", data1, nook);
		goto Cleanup;
	}

	//Sync the elements

	nook_disk->part[first_minor].nr_sects
		=gp->part[first_minor].nr_sects;
		

	for(counter=first_minor; counter<end_minor; counter++)
		nook_disk->sizes[counter]
			=gp->sizes[counter]; 
		
	printk("Inside grok partitions 4");	
 Cleanup:
	NOOKS_KWRAPPER_EXIT();
	return ;



}

void nooks_w_grok_partitions(struct gendisk *dev, int drive, unsigned minors, long size)
{

	NOOKS_WRAPPER_ENTER();

	NOOKS_KERNEL_CALL4(nooks_k_grok_partitions, dev, drive, minors, size);

	NOOKS_WRAPPER_EXIT();

}


/***************************ide-probemod.o****************************/


void NOOKS_KWRAPPER(add_gendisk)(struct gendisk *nook_gp)
{

	pnook_t nook = GET_CURRENT_NOOK();
	int major, minor, result = 0;
	struct gendisk *gp;
	pnook_driver_t old_driver=NULL;
	NOOKS_KWRAPPER_ENTER();

	
	/*Sync max_readahead structure, this is the ideal place*/

	major=nook_gp->major;
	minor=nook_gp->nr_real * nook_gp->max_p ;

	max_readahead[major]
	= (int *) nooks_kmalloc(sizeof(int) * minor,
					   GFP_KERNEL);
	
	if(max_readahead[major]==NULL)
	{
		printk("No memory allocated for max_readahead");		
		result = -ENOMEM;
		NOOKS_FAULT(enomem);
		goto clean;
	}
	else
	{
		result = nooks_add_resource_elem(nook, sector_info_e, 
					max_readahead[major], NULL);

		if (result < 0) 
		{
			printk("Unable to add max_readahead\n");
		}
	}


	
	max_sectors[major]
	= (int *) nooks_kmalloc(sizeof(int) * minor,
					   GFP_KERNEL);
	if(max_sectors[major]==NULL)
	{
		printk("No memory allocated for max_sectors");		
		result = -ENOMEM;
		NOOKS_FAULT(enomem);
		goto clean;
	}
	else
	{

		result = nooks_add_resource_elem(nook, sector_info_e, 
					max_sectors[major], NULL);

		if (result < 0) {
			printk("Unable to add max_sectors\n");
		}
	}

	
	NOOKS_WRAPPER(max_readahead_num)[major]
	=  minor;

	blksize_size[major]
	= (int *) nooks_kmalloc(sizeof(int) * minor,
					   GFP_KERNEL);

	if(blksize_size[major]==NULL)
	{
		printk("No memory allocated for blksize_size");		
		result = -ENOMEM;
		NOOKS_FAULT(enomem);
		goto clean;
	}
	else
	{
		result = nooks_add_resource_elem(nook, sector_info_e, 
					blksize_size[major], NULL);

		if (result < 0) {
			printk("Unable to add blksize_size\n");
		}
	}

	/* copy parameters from driver to kernel */

	gp = nooks_kmalloc(sizeof(struct gendisk), NOOKS_MEM_FLAGS);
	if (gp == NULL) {
		result = -ENOMEM;
		NOOKS_FAULT(enomem);
		goto clean;
	}
	

	result = nooks_memcpy(gp, nook_gp, sizeof(struct gendisk));
	if (result < 0) {
		/* FIXME parameter fault */
		NOOKS_FAULT(parameter);
		goto err1;
	}

	gp->sizes=nooks_kmalloc(minor * sizeof(int), GFP_KERNEL);
	//gp->part=nooks_kmalloc(minor * sizeof(struct hd_struct), GFP_KERNEL);

	//if(!gp->sizes || !gp->part)
	if(!gp->sizes)
	{
		PERROR("Couldnt Allocate Memory for gendisk\n");
		goto err1;	

	}

	
	/*driver = nooks_create_driver(nook, blkops_e, 
				NOOK_DRIVER_NO_MAJOR, NULL);

	if (driver == NULL) {
		result = -ENOMEM;
		goto err2;
	}


	driver->data = gp;*/
	
	/**************************/

	
	old_driver = nooks_find_driver_in_nook(gp->major, nook);
	
	if (old_driver == NULL) {
		PERROR(" ERROR: no driver %d in nook %s, function %s\n",
		       gp->major, nook->name, __FUNCTION__);
		result = -ENOENT;
	} 
	else
	{
		gp->fops=&old_driver->wrapper_operations.bdops;
	}
	
	/**************************/



	result = nooks_add_resource_elem(nook, gendisk_e, nook_gp, (void *)gp);
	if (result < 0) {
		goto err1;
	}

	NOOKS_SWRAPPER(add_gendisk)((struct gendisk *) gp);

	goto clean;

err1:
	nooks_kfree(gp);
clean:
	NOOKS_KWRAPPER_EXIT();
	return;


}

void nooks_w_add_gendisk(struct gendisk *nook_gp)
{

	NOOKS_WRAPPER_ENTER();

	NOOKS_KERNEL_CALL1(nooks_k_add_gendisk, nook_gp);

	NOOKS_WRAPPER_EXIT();
	

}


void nooks_blkdev_dequeue_request(struct request *rq)
{
  blkdev_dequeue_request(rq);
}


void NOOKS_KWRAPPER(blk_init_queue)(request_queue_t * arg0, request_fn_proc * arg1)
{
  //NOOKS_SWRAPPER(blk_init_queue)(arg0, arg1);
  pnook_t nook = GET_CURRENT_NOOK();
	int result = 0;
	pnook_driver_t driver = NULL;
	NOOKS_KWRAPPER_ENTER();

	driver = nooks_create_driver(nook, blkops_e, NOOK_DRIVER_NO_MAJOR, NULL);
	if (driver == NULL) {
		result = -ENOMEM;
		goto err2;
	}

	printk("ADDRESS OF Q: %p\n", arg0);

	driver->data=arg0;

		// Copy the operations, preserving NULL entries
	nooks_iwrapper_copy_blkops(  arg1,
				     &driver->operations.blkops,
				     driver->iwrapper_operations.blkops,
				     &driver->wrapper_operations.blkops);



	blk_init_queue(arg0,driver->wrapper_operations.blkops.request_fn);

	
	

err2:
	NOOKS_KWRAPPER_EXIT();
	return;



}

void NOOKS_WRAPPER(blk_init_queue)(request_queue_t * arg0, request_fn_proc * arg1)
{
  NOOKS_KERNEL_CALL2(nooks_k_blk_init_queue, arg0, arg1);
  return;
}
