/*
 * nooks-ksyms.c -- exported symbols for wrappers od system functions
 *
 * Copyright (C) 2001 Mike Swift
 *
 * The source code in this file can be freely used, adapted,
 * and redistributed in source or binary form, so long as an
 * acknowledgment appears in derived source files.  
 * No warranty is attached;
 * we cannot take responsibility for errors or fitness for use.
 *
 */

#include "nooks-i.h"
#include "nooks-wrappers.h"
#include "nooks-sock.h"
#ifdef __GENKSYMS__
#define NOOKS_EXPORT_SYMBOL(_x_) EXPORT_SYMBOL(nooks_w_ ## _x_)
#define NOOKS_EXPORT_SYMBOL_NOVERS(_x_) EXPORT_SYMBOL_NOVERS(nooks_w_ ## _x_)
#else // __GENKSYMS__
#define NOOKS_EXPORT_SYMBOL(_x_) EXPORT_SYMBOL(nooks_w_ ## _x_)
#define NOOKS_EXPORT_SYMBOL_NOVERS(_x_) EXPORT_SYMBOL_NOVERS(nooks_w_ ## _x_)
#endif // __GENKSYMS__


NOOKS_EXPORT_SYMBOL(add_timer);
NOOKS_EXPORT_SYMBOL(add_wait_queue);
NOOKS_EXPORT_SYMBOL(alloc_etherdev);
NOOKS_EXPORT_SYMBOL(alloc_kiovec);
NOOKS_EXPORT_SYMBOL(alloc_skb);
NOOKS_EXPORT_SYMBOL(bh_task_vec);
NOOKS_EXPORT_SYMBOL(blk_cleanup_queue);
NOOKS_EXPORT_SYMBOL(blk_dev);
NOOKS_EXPORT_SYMBOL(blk_init_queue);
NOOKS_EXPORT_SYMBOL(blk_ioctl);
NOOKS_EXPORT_SYMBOL(blk_queue_make_request);
NOOKS_EXPORT_SYMBOL(blk_size);
NOOKS_EXPORT_SYMBOL(blksize_size);
NOOKS_EXPORT_SYMBOL(check_disk_change);
NOOKS_EXPORT_SYMBOL(__check_region);
NOOKS_EXPORT_SYMBOL(__const_udelay);
NOOKS_EXPORT_SYMBOL(cpu_raise_softirq);
NOOKS_EXPORT_SYMBOL(create_proc_entry);
NOOKS_EXPORT_SYMBOL(proc_mkdir);
NOOKS_EXPORT_SYMBOL(dev_kfree_skb_irq);
NOOKS_EXPORT_SYMBOL(del_timer);
NOOKS_EXPORT_SYMBOL(do_gettimeofday);
#ifdef CONFIG_KGDB_THREAD
NOOKS_EXPORT_SYMBOL(kern_schedule);
#else
NOOKS_EXPORT_SYMBOL(do_schedule);
#endif
NOOKS_EXPORT_SYMBOL_NOVERS(__down_failed);
NOOKS_EXPORT_SYMBOL_NOVERS(__down_failed_interruptible);
NOOKS_EXPORT_SYMBOL(end_that_request_first);
NOOKS_EXPORT_SYMBOL(end_that_request_last);
NOOKS_EXPORT_SYMBOL(ether_setup);
NOOKS_EXPORT_SYMBOL(eth_type_trans);
NOOKS_EXPORT_SYMBOL(fasync_helper);
NOOKS_EXPORT_SYMBOL(free_irq);
NOOKS_EXPORT_SYMBOL(free_kiovec);
NOOKS_EXPORT_SYMBOL(free_pages);
NOOKS_EXPORT_SYMBOL(fsync_dev);
NOOKS_EXPORT_SYMBOL(gendisk_head);
NOOKS_EXPORT_SYMBOL(__generic_copy_from_user);
NOOKS_EXPORT_SYMBOL(__generic_copy_to_user);
NOOKS_EXPORT_SYMBOL(nooks_generic_copy_from_user_nocheck);
NOOKS_EXPORT_SYMBOL(nooks_generic_copy_to_user_nocheck);
EXPORT_SYMBOL(nooks_generic_copy_to_user_nocheck);
EXPORT_SYMBOL(nooks_generic_copy_from_user_nocheck);
NOOKS_EXPORT_SYMBOL(__get_free_pages);
NOOKS_EXPORT_SYMBOL(hardsect_size);
NOOKS_EXPORT_SYMBOL(init_mm);
NOOKS_EXPORT_SYMBOL(interruptible_sleep_on);
NOOKS_EXPORT_SYMBOL(interruptible_sleep_on_timeout);
NOOKS_EXPORT_SYMBOL(__invalidate_buffers);
NOOKS_EXPORT_SYMBOL(iomem_resource);
NOOKS_EXPORT_SYMBOL(ioport_resource);
NOOKS_EXPORT_SYMBOL(__ioremap);
NOOKS_EXPORT_SYMBOL(iounmap);
NOOKS_EXPORT_SYMBOL(jiffies);
NOOKS_EXPORT_SYMBOL(kfree);
NOOKS_EXPORT_SYMBOL(__kfree_skb);
NOOKS_EXPORT_SYMBOL(kill_fasync);
NOOKS_EXPORT_SYMBOL(kmalloc);
NOOKS_EXPORT_SYMBOL(kmem_cache_alloc);
NOOKS_EXPORT_SYMBOL(kmem_cache_create);
NOOKS_EXPORT_SYMBOL(kmem_cache_destroy);
NOOKS_EXPORT_SYMBOL(kmem_cache_free);
NOOKS_EXPORT_SYMBOL(map_user_kiobuf);
NOOKS_EXPORT_SYMBOL(mem_map);
#ifdef CONFIG_NOOKS_STATS
NOOKS_EXPORT_SYMBOL(ms_access_int);
NOOKS_EXPORT_SYMBOL(ms_access_io);
NOOKS_EXPORT_SYMBOL(ms_ops_count);
#endif // CONFIG_NOOKS_STATS
NOOKS_EXPORT_SYMBOL(netif_rx);
NOOKS_EXPORT_SYMBOL(__netif_schedule);
NOOKS_EXPORT_SYMBOL(panic);
NOOKS_EXPORT_SYMBOL(__pollwait);
NOOKS_EXPORT_SYMBOL(printk);
NOOKS_EXPORT_SYMBOL(probe_irq_off);
NOOKS_EXPORT_SYMBOL(probe_irq_on);
NOOKS_EXPORT_SYMBOL(read_ahead);
NOOKS_EXPORT_SYMBOL(refile_buffer);
NOOKS_EXPORT_SYMBOL(register_blkdev);
NOOKS_EXPORT_SYMBOL(register_chrdev);
NOOKS_EXPORT_SYMBOL(register_disk);
NOOKS_EXPORT_SYMBOL(register_netdev);
NOOKS_EXPORT_SYMBOL(__release_region);
NOOKS_EXPORT_SYMBOL(release_resource);
NOOKS_EXPORT_SYMBOL(remove_proc_entry);
NOOKS_EXPORT_SYMBOL(remove_wait_queue);
NOOKS_EXPORT_SYMBOL(request_irq);
NOOKS_EXPORT_SYMBOL(__request_region);
// NOOKS_EXPORT_SYMBOL(schedule);
NOOKS_EXPORT_SYMBOL(schedule_task);
NOOKS_EXPORT_SYMBOL(skb_over_panic);
NOOKS_EXPORT_SYMBOL(skb_under_panic);
NOOKS_EXPORT_SYMBOL(sleep_on);
NOOKS_EXPORT_SYMBOL(sleep_on_timeout);
NOOKS_EXPORT_SYMBOL(softnet_data);
NOOKS_EXPORT_SYMBOL(sprintf);
NOOKS_EXPORT_SYMBOL(__tasklet_hi_schedule);
NOOKS_EXPORT_SYMBOL(tasklet_init);
NOOKS_EXPORT_SYMBOL(tasklet_kill);
NOOKS_EXPORT_SYMBOL(tasklet_enable);
NOOKS_EXPORT_SYMBOL(tasklet_disable);
NOOKS_EXPORT_SYMBOL(__tasklet_schedule);
NOOKS_EXPORT_SYMBOL(tq_immediate);
NOOKS_EXPORT_SYMBOL(unmap_kiobuf);
NOOKS_EXPORT_SYMBOL(unregister_blkdev);
NOOKS_EXPORT_SYMBOL(unregister_chrdev);
NOOKS_EXPORT_SYMBOL(unregister_netdev);
NOOKS_EXPORT_SYMBOL_NOVERS(__up_wakeup);
NOOKS_EXPORT_SYMBOL(vfree);
NOOKS_EXPORT_SYMBOL(__vmalloc);
NOOKS_EXPORT_SYMBOL(__wake_up);
NOOKS_EXPORT_SYMBOL(bread);
NOOKS_EXPORT_SYMBOL( __brelse);
NOOKS_EXPORT_SYMBOL(disable_irq);
NOOKS_EXPORT_SYMBOL(disable_irq_nosync);
NOOKS_EXPORT_SYMBOL(enable_irq);
NOOKS_EXPORT_SYMBOL(do_softirq);
NOOKS_EXPORT_SYMBOL(irq_stat);
NOOKS_EXPORT_SYMBOL(mod_timer);
NOOKS_EXPORT_SYMBOL(__netdev_watchdog_up);
NOOKS_EXPORT_SYMBOL(pci_alloc_consistent);
NOOKS_EXPORT_SYMBOL(pcibios_present);
NOOKS_EXPORT_SYMBOL(pci_enable_device);
NOOKS_EXPORT_SYMBOL(pci_enable_wake);
NOOKS_EXPORT_SYMBOL(pci_find_class);
NOOKS_EXPORT_SYMBOL(pci_find_device);
NOOKS_EXPORT_SYMBOL(pci_free_consistent);
NOOKS_EXPORT_SYMBOL(pci_read_config_byte);
NOOKS_EXPORT_SYMBOL(pci_read_config_word);
NOOKS_EXPORT_SYMBOL(pci_read_config_dword);
NOOKS_EXPORT_SYMBOL(pci_register_driver);
NOOKS_EXPORT_SYMBOL(pci_unregister_driver);
NOOKS_EXPORT_SYMBOL(pci_restore_state);
NOOKS_EXPORT_SYMBOL(pci_save_state);
NOOKS_EXPORT_SYMBOL(pci_set_dma_mask);
NOOKS_EXPORT_SYMBOL(pci_set_master);
NOOKS_EXPORT_SYMBOL(pci_set_power_state);
NOOKS_EXPORT_SYMBOL(pci_write_config_byte);
NOOKS_EXPORT_SYMBOL(pci_write_config_word);
NOOKS_EXPORT_SYMBOL(pci_write_config_dword);
NOOKS_EXPORT_SYMBOL(pci_request_regions);
NOOKS_EXPORT_SYMBOL(pci_release_regions);
NOOKS_EXPORT_SYMBOL(pci_disable_device);
NOOKS_EXPORT_SYMBOL(proc_net);
NOOKS_EXPORT_SYMBOL(qdisc_reset);
#ifdef CONFIG_SCSI
NOOKS_EXPORT_SYMBOL(scsi_command_size);
NOOKS_EXPORT_SYMBOL(scsi_partsize);
NOOKS_EXPORT_SYMBOL(scsi_register);
NOOKS_EXPORT_SYMBOL(scsi_register_module);
NOOKS_EXPORT_SYMBOL(scsi_unregister_module);
NOOKS_EXPORT_SYMBOL(scsi_unregister);
#endif // CONFIG_SCSI
NOOKS_EXPORT_SYMBOL(skb_realloc_headroom);
NOOKS_EXPORT_SYMBOL(simple_strtoul);
NOOKS_EXPORT_SYMBOL(strtok);
NOOKS_EXPORT_SYMBOL(sock_alloc);
NOOKS_EXPORT_SYMBOL(tcp_sync_mss);
NOOKS_EXPORT_SYMBOL(__get_user_1);
NOOKS_EXPORT_SYMBOL(__get_user_2);
NOOKS_EXPORT_SYMBOL(__get_user_4);
NOOKS_EXPORT_SYMBOL(nooks_get_user_ext);
EXPORT_SYMBOL(nooks_get_user_ext);
NOOKS_EXPORT_SYMBOL(filp_open);
NOOKS_EXPORT_SYMBOL(tcp_write_xmit);
NOOKS_EXPORT_SYMBOL(sock_sendmsg);
NOOKS_EXPORT_SYMBOL(_ctype);
NOOKS_EXPORT_SYMBOL(add_wait_queue_exclusive);
NOOKS_EXPORT_SYMBOL(__lock_sock);
NOOKS_EXPORT_SYMBOL(tcp_openreq_cachep);
NOOKS_EXPORT_SYMBOL(sysctl_intvec);
NOOKS_EXPORT_SYMBOL(__release_sock);
NOOKS_EXPORT_SYMBOL(sysctl_string);
NOOKS_EXPORT_SYMBOL(proc_dostring);
NOOKS_EXPORT_SYMBOL(proc_dointvec);
NOOKS_EXPORT_SYMBOL(strstr);
NOOKS_EXPORT_SYMBOL(unregister_sysctl_table);
NOOKS_EXPORT_SYMBOL(sk_free);
NOOKS_EXPORT_SYMBOL(tcp_v4_lookup_listener);
NOOKS_EXPORT_SYMBOL(do_generic_file_read);
NOOKS_EXPORT_SYMBOL(sock_recvmsg);
NOOKS_EXPORT_SYMBOL(fput);
NOOKS_EXPORT_SYMBOL(sock_release);
NOOKS_EXPORT_SYMBOL(tcp_cwnd_application_limited);
NOOKS_EXPORT_SYMBOL(sock_create);
NOOKS_EXPORT_SYMBOL(daemonize);
NOOKS_EXPORT_SYMBOL(kernel_thread);
NOOKS_EXPORT_SYMBOL(register_sysctl_table);
NOOKS_EXPORT_SYMBOL(get_zeroed_page);

/* steve added the following
   Export our time variable so the driver can read it. */
EXPORT_SYMBOL(nooks_call_time);
EXPORT_SYMBOL(nooks_dummy_trap1);
EXPORT_SYMBOL(nooks_dummy_trap2);
EXPORT_SYMBOL(nooks_illegal_inst_trap);
EXPORT_SYMBOL(nooks_put_user_check);
NOOKS_EXPORT_SYMBOL(nooks_put_user_check);

EXPORT_SYMBOL(set_current_comment);
NOOKS_EXPORT_SYMBOL(set_current_comment);

NOOKS_EXPORT_SYMBOL(block_all_signals_but);
//EXPORT_SYMBOL(block_all_signals_but);

EXPORT_SYMBOL(set_fs);
NOOKS_EXPORT_SYMBOL(set_fs);

EXPORT_SYMBOL(set_pf_superpriv);
NOOKS_EXPORT_SYMBOL(set_pf_superpriv);

EXPORT_SYMBOL(__set_current_state);
NOOKS_EXPORT_SYMBOL(__set_current_state);

NOOKS_EXPORT_SYMBOL(release_sock);
NOOKS_EXPORT_SYMBOL(lock_sock);
NOOKS_EXPORT_SYMBOL(sock_put);
EXPORT_SYMBOL(release_sock);
EXPORT_SYMBOL(lock_sock);
EXPORT_SYMBOL(sock_put);

NOOKS_EXPORT_SYMBOL(tcp_openreq_alloc);
NOOKS_EXPORT_SYMBOL(tcp_openreq_fastfree);
NOOKS_EXPORT_SYMBOL(tcp_openreq_free);

EXPORT_SYMBOL(tcp_openreq_alloc);
EXPORT_SYMBOL(tcp_openreq_fastfree);
EXPORT_SYMBOL(tcp_openreq_free);

EXPORT_SYMBOL(tcp_acceptq_queue);
NOOKS_EXPORT_SYMBOL(tcp_acceptq_queue);


NOOKS_EXPORT_SYMBOL(try_inc_mod_count);
NOOKS_EXPORT_SYMBOL(sys_close);
NOOKS_EXPORT_SYMBOL(request_module);
NOOKS_EXPORT_SYMBOL(isa_dma_bridge_buggy);
NOOKS_EXPORT_SYMBOL(remap_page_range);
NOOKS_EXPORT_SYMBOL(free_dma);
NOOKS_EXPORT_SYMBOL(no_llseek);
NOOKS_EXPORT_SYMBOL(request_dma);
NOOKS_EXPORT_SYMBOL(mem_map_reserve);
EXPORT_SYMBOL(mem_map_reserve);
NOOKS_EXPORT_SYMBOL(mem_map_unreserve);
EXPORT_SYMBOL(mem_map_unreserve);
NOOKS_EXPORT_SYMBOL(schedule_timeout);
NOOKS_EXPORT_SYMBOL(proc_doulongvec_ms_jiffies_minmax);
NOOKS_EXPORT_SYMBOL(proc_dointvec_minmax);
NOOKS_EXPORT_SYMBOL(block_read_full_page);
NOOKS_EXPORT_SYMBOL(block_sync_page);
NOOKS_EXPORT_SYMBOL(block_write_full_page);
NOOKS_EXPORT_SYMBOL(clear_inode);
NOOKS_EXPORT_SYMBOL(cont_prepare_write);
NOOKS_EXPORT_SYMBOL(d_alloc_root);
NOOKS_EXPORT_SYMBOL(d_drop);
NOOKS_EXPORT_SYMBOL(dget_locked);
NOOKS_EXPORT_SYMBOL(event);
NOOKS_EXPORT_SYMBOL(file_fsync);
NOOKS_EXPORT_SYMBOL(generic_block_bmap);
NOOKS_EXPORT_SYMBOL(generic_commit_write);
NOOKS_EXPORT_SYMBOL(generic_file_llseek);
NOOKS_EXPORT_SYMBOL(generic_file_mmap);
NOOKS_EXPORT_SYMBOL(generic_file_read);
NOOKS_EXPORT_SYMBOL(generic_file_write);
NOOKS_EXPORT_SYMBOL(generic_read_dir);
NOOKS_EXPORT_SYMBOL(getblk);
NOOKS_EXPORT_SYMBOL(get_empty_inode);
NOOKS_EXPORT_SYMBOL(iget4);
NOOKS_EXPORT_SYMBOL(igrab);
NOOKS_EXPORT_SYMBOL(inode_change_ok);
NOOKS_EXPORT_SYMBOL(inode_setattr);
NOOKS_EXPORT_SYMBOL(insert_inode_hash);
NOOKS_EXPORT_SYMBOL(iput);
NOOKS_EXPORT_SYMBOL(is_bad_inode);
NOOKS_EXPORT_SYMBOL(iunique);
NOOKS_EXPORT_SYMBOL(kdevname);
NOOKS_EXPORT_SYMBOL(ll_rw_block);
NOOKS_EXPORT_SYMBOL(load_nls);
NOOKS_EXPORT_SYMBOL(load_nls_default);
NOOKS_EXPORT_SYMBOL(make_bad_inode);
NOOKS_EXPORT_SYMBOL(mark_buffer_dirty);
NOOKS_EXPORT_SYMBOL(__mark_inode_dirty);
NOOKS_EXPORT_SYMBOL(set_blocksize);
NOOKS_EXPORT_SYMBOL(sys_tz);
NOOKS_EXPORT_SYMBOL(unload_nls);
NOOKS_EXPORT_SYMBOL(utf8_wcstombs);
NOOKS_EXPORT_SYMBOL(xtime);
NOOKS_EXPORT_SYMBOL(d_find_alias);
NOOKS_EXPORT_SYMBOL(d_instantiate);
NOOKS_EXPORT_SYMBOL(d_invalidate);
NOOKS_EXPORT_SYMBOL(dput);
NOOKS_EXPORT_SYMBOL(d_rehash);
NOOKS_EXPORT_SYMBOL(register_filesystem);
NOOKS_EXPORT_SYMBOL(strnicmp);
NOOKS_EXPORT_SYMBOL(unregister_filesystem);
NOOKS_EXPORT_SYMBOL(utf8_mbstowcs);
NOOKS_EXPORT_SYMBOL(new_inode);
NOOKS_EXPORT_SYMBOL(isapnp_find_card);
NOOKS_EXPORT_SYMBOL(isapnp_find_dev);
NOOKS_EXPORT_SYMBOL(isapnp_config_prepare);
NOOKS_EXPORT_SYMBOL(isapnp_config_activate);
NOOKS_EXPORT_SYMBOL(isapnp_config_deactivate);
NOOKS_EXPORT_SYMBOL(isapnp_probe_devs);

/* added for drm */
NOOKS_EXPORT_SYMBOL(mtrr_add);
NOOKS_EXPORT_SYMBOL(inter_module_register);
NOOKS_EXPORT_SYMBOL(si_meminfo);
NOOKS_EXPORT_SYMBOL(inter_module_put);
NOOKS_EXPORT_SYMBOL(block_all_signals);
NOOKS_EXPORT_SYMBOL(boot_cpu_data);
NOOKS_EXPORT_SYMBOL(inter_module_get);
NOOKS_EXPORT_SYMBOL(high_memory);
NOOKS_EXPORT_SYMBOL(pci_pool_free);
NOOKS_EXPORT_SYMBOL(pci_pool_alloc);
NOOKS_EXPORT_SYMBOL(mtrr_del);
NOOKS_EXPORT_SYMBOL(pci_pool_destroy);
NOOKS_EXPORT_SYMBOL(pci_find_slot);
NOOKS_EXPORT_SYMBOL(rwsem_down_write_failed);
NOOKS_EXPORT_SYMBOL(rwsem_wake);
NOOKS_EXPORT_SYMBOL(pci_pool_create);
NOOKS_EXPORT_SYMBOL(do_mmap_pgoff);
NOOKS_EXPORT_SYMBOL(unblock_all_signals);
NOOKS_EXPORT_SYMBOL(inter_module_unregister);
NOOKS_EXPORT_SYMBOL(do_munmap);
/* rwsem */
NOOKS_EXPORT_SYMBOL(down_read);
NOOKS_EXPORT_SYMBOL(down_write);
NOOKS_EXPORT_SYMBOL(up_read);
NOOKS_EXPORT_SYMBOL(up_write);
NOOKS_EXPORT_SYMBOL(queue_task);

EXPORT_SYMBOL(down_read);
EXPORT_SYMBOL(down_write);
EXPORT_SYMBOL(up_read);
EXPORT_SYMBOL(up_write);
EXPORT_SYMBOL(queue_task);

/* end rwsem */
/* end drm */
/* for agp */
NOOKS_EXPORT_SYMBOL(misc_deregister);
NOOKS_EXPORT_SYMBOL(pm_unregister_all);
NOOKS_EXPORT_SYMBOL(pm_register);
NOOKS_EXPORT_SYMBOL(pm_unregister);
NOOKS_EXPORT_SYMBOL(pci_devices);
NOOKS_EXPORT_SYMBOL(misc_register);
NOOKS_EXPORT_SYMBOL(_alloc_pages);
NOOKS_EXPORT_SYMBOL(get_page);
NOOKS_EXPORT_SYMBOL(LockPage);
NOOKS_EXPORT_SYMBOL(unlock_page);
NOOKS_EXPORT_SYMBOL(put_page_testzero);
NOOKS_EXPORT_SYMBOL(SetPageReserved);
NOOKS_EXPORT_SYMBOL(ClearPageReserved);
/* end agp */


EXPORT_SYMBOL(new_inode);
EXPORT_SYMBOL(d_drop);
EXPORT_SYMBOL(get_page);
EXPORT_SYMBOL(LockPage);
EXPORT_SYMBOL(put_page_testzero);
EXPORT_SYMBOL(SetPageReserved);
EXPORT_SYMBOL(ClearPageReserved);

//NOOKS_EXPORT_SYMBOL(proc_mkdir);
NOOKS_EXPORT_SYMBOL(del_gendisk);
NOOKS_EXPORT_SYMBOL(myfree_irq);
NOOKS_EXPORT_SYMBOL(max_sectors);
NOOKS_EXPORT_SYMBOL(proc_symlink);
NOOKS_EXPORT_SYMBOL(invalidate_device);
NOOKS_EXPORT_SYMBOL(max_readahead);
NOOKS_EXPORT_SYMBOL(wait_for_completion);
NOOKS_EXPORT_SYMBOL(add_blkdev_randomness);
NOOKS_EXPORT_SYMBOL(nooks_blkdev_dequeue_request);
EXPORT_SYMBOL(nooks_blkdev_dequeue_request);
NOOKS_EXPORT_SYMBOL(isapnp_present);

/************ide-disk.o****************/
NOOKS_EXPORT_SYMBOL(vm_max_readahead);
NOOKS_EXPORT_SYMBOL(grok_partitions);
NOOKS_EXPORT_SYMBOL(invalidate_bdev);

/************ide-probemod.o****************/
NOOKS_EXPORT_SYMBOL(drive_info);
NOOKS_EXPORT_SYMBOL(add_gendisk);


NOOKS_EXPORT_SYMBOL(register_reboot_notifier);
NOOKS_EXPORT_SYMBOL(unregister_reboot_notifier);
NOOKS_EXPORT_SYMBOL(pci_dev_driver);
NOOKS_EXPORT_SYMBOL(yield);
EXPORT_SYMBOL(yield);

NOOKS_EXPORT_SYMBOL(nooks___cpu_bh_enable);
NOOKS_EXPORT_SYMBOL(nooks_cpu_bh_disable);
NOOKS_EXPORT_SYMBOL(nooks_local_bh_enable);
NOOKS_EXPORT_SYMBOL(nooks_in_softirq);
EXPORT_SYMBOL(nooks___cpu_bh_enable);
EXPORT_SYMBOL(nooks_cpu_bh_disable);
EXPORT_SYMBOL(nooks_local_bh_enable);
EXPORT_SYMBOL(nooks_in_softirq);
