#ifdef CONFIG_NOOKS_SHADOW
int snetops_hard_header_cache(struct neighbour *neigh, struct hh_cache *hh, int __driver_result, pnook_driver_t __driver)
{
  int result = __driver_result;
  shadow_log(__driver, __FUNCTION__, (int) __driver_result);
  return(result);
}

int snetops_open(struct net_device *dev, int __driver_result, pnook_driver_t __driver)
{
  int result = __driver_result;
  shadow_log(__driver, __FUNCTION__, (int) __driver_result);
  return(result);
}

int snetops_hard_header(struct sk_buff *skb, struct net_device *dev, unsigned short type, void *daddr, void *saddr, unsigned len, int __driver_result, pnook_driver_t __driver)
{
  int result = __driver_result;
  shadow_log(__driver, __FUNCTION__, (int) __driver_result);
  return(result);
}

int snetops_init(struct net_device *dev, int __driver_result, pnook_driver_t __driver)
{
  int result = __driver_result;
  shadow_log(__driver, __FUNCTION__, (int) __driver_result);
  return(result);
}

int snetops_do_ioctl(struct net_device *dev, struct ifreq *ifr, int cmd, int __driver_result, pnook_driver_t __driver)
{
  int result = __driver_result;
  shadow_log(__driver, __FUNCTION__, (int) __driver_result);
  return(result);
}

int snetops_hard_header_parse(struct sk_buff *skb, unsigned char *haddr, int __driver_result, pnook_driver_t __driver)
{
  int result = __driver_result;
  shadow_log(__driver, __FUNCTION__, (int) __driver_result);
  return(result);
}

int snetops_stop(struct net_device *dev, int __driver_result, pnook_driver_t __driver)
{
  int result = __driver_result;
  shadow_log(__driver, __FUNCTION__, (int) __driver_result);
  return(result);
}

struct iw_statistics* snetops_get_wireless_stats(struct net_device *dev, struct iw_statistics* __driver_result, pnook_driver_t __driver)
{
  struct iw_statistics* result = __driver_result;
  shadow_log(__driver, __FUNCTION__, (int) __driver_result);
  return(result);
}

void snetops_header_cache_update(struct hh_cache *hh, struct net_device *dev, unsigned char * haddr, pnook_driver_t __driver)
{
  shadow_log(__driver, __FUNCTION__, 0);
  return;
}

void snetops_uninit(struct net_device *dev, pnook_driver_t __driver)
{
  shadow_log(__driver, __FUNCTION__, 0);
  return;
}

void snetops_tx_timeout(struct net_device *dev, pnook_driver_t __driver)
{
  shadow_log(__driver, __FUNCTION__, 0);
  return;
}

void snetops_set_multicast_list(struct net_device *dev, pnook_driver_t __driver)
{
  shadow_log(__driver, __FUNCTION__, 0);
  return;
}

void snetops_destructor(struct net_device *dev, pnook_driver_t __driver)
{
  shadow_log(__driver, __FUNCTION__, 0);
  return;
}

int snetops_hard_start_xmit(struct sk_buff *skb, struct net_device *dev, int __driver_result, pnook_driver_t __driver)
{
  int result = __driver_result;
  shadow_log(__driver, __FUNCTION__, (int) __driver_result);
  return(result);
}

int snetops_set_mac_address(struct net_device *dev, void *addr, int __driver_result, pnook_driver_t __driver)
{
  int result = __driver_result;
  shadow_log(__driver, __FUNCTION__, (int) __driver_result);
  return(result);
}

int snetops_neigh_setup(struct net_device *dev, struct neigh_parms * parms, int __driver_result, pnook_driver_t __driver)
{
  int result = __driver_result;
  shadow_log(__driver, __FUNCTION__, (int) __driver_result);
  return(result);
}

int snetops_accept_fastpath(struct net_device *dev, struct dst_entry *entry, int __driver_result, pnook_driver_t __driver)
{
  int result = __driver_result;
  shadow_log(__driver, __FUNCTION__, (int) __driver_result);
  return(result);
}

int snetops_rebuild_header(struct sk_buff *skb, int __driver_result, pnook_driver_t __driver)
{
  int result = __driver_result;
  shadow_log(__driver, __FUNCTION__, (int) __driver_result);
  return(result);
}

int snetops_set_config(struct net_device *dev, struct ifmap *map, int __driver_result, pnook_driver_t __driver)
{
  int result = __driver_result;
  shadow_log(__driver, __FUNCTION__, (int) __driver_result);
  return(result);
}

int snetops_change_mtu(struct net_device *dev, int new_mtu, int __driver_result, pnook_driver_t __driver)
{
  int result = __driver_result;
  shadow_log(__driver, __FUNCTION__, (int) __driver_result);
  return(result);
}

int shadow_add_snetops(pnook_driver_t driver, void * arg)
{
  int result = 0;
  result = shadow_add_interface(driver);
  if (result >= 0) {
    driver->shadow_operations->snetops = &shadow_netops;
    driver->iwrapper_operations.netops->hard_header_cache.wrapped = shadow_netops.hard_header_cache;
    driver->iwrapper_operations.netops->open.wrapped = shadow_netops.open;
    driver->iwrapper_operations.netops->hard_header.wrapped = shadow_netops.hard_header;
    driver->iwrapper_operations.netops->init.wrapped = shadow_netops.init;
    driver->iwrapper_operations.netops->do_ioctl.wrapped = shadow_netops.do_ioctl;
    driver->iwrapper_operations.netops->hard_header_parse.wrapped = shadow_netops.hard_header_parse;
    driver->iwrapper_operations.netops->stop.wrapped = shadow_netops.stop;
    driver->iwrapper_operations.netops->get_wireless_stats.wrapped = shadow_netops.get_wireless_stats;
    driver->iwrapper_operations.netops->header_cache_update.wrapped = shadow_netops.header_cache_update;
    driver->iwrapper_operations.netops->uninit.wrapped = shadow_netops.uninit;
    driver->iwrapper_operations.netops->tx_timeout.wrapped = shadow_netops.tx_timeout;
    driver->iwrapper_operations.netops->set_multicast_list.wrapped = shadow_netops.set_multicast_list;
    driver->iwrapper_operations.netops->destructor.wrapped = shadow_netops.destructor;
    driver->iwrapper_operations.netops->hard_start_xmit.wrapped = shadow_netops.hard_start_xmit;
    driver->iwrapper_operations.netops->set_mac_address.wrapped = shadow_netops.set_mac_address;
    driver->iwrapper_operations.netops->neigh_setup.wrapped = shadow_netops.neigh_setup;
    driver->iwrapper_operations.netops->accept_fastpath.wrapped = shadow_netops.accept_fastpath;
    driver->iwrapper_operations.netops->rebuild_header.wrapped = shadow_netops.rebuild_header;
    driver->iwrapper_operations.netops->get_stats.wrapped = shadow_netops.get_stats;
    driver->iwrapper_operations.netops->set_config.wrapped = shadow_netops.set_config;
    driver->iwrapper_operations.netops->change_mtu.wrapped = shadow_netops.change_mtu;
    driver->shadow_kernel_operations->sknetops = &shadow_sknetops;
  } else {
    if (result == -EINVAL) {
      result = 0; // no shadow running
    }
  }
  return result;
}

void shadow_del_snetops(pnook_driver_t driver)
{
  shadow_del_interface(driver);
}

void smops_cleanup(pnook_driver_t __driver)
{
  shadow_log(__driver, __FUNCTION__, 0);
  return;
}

int smops_can_unload(int __driver_result, pnook_driver_t __driver)
{
  int result = __driver_result;
  shadow_log(__driver, __FUNCTION__, (int) __driver_result);
  return(result);
}

int shadow_add_smops(pnook_driver_t driver, void * arg)
{
  int result = 0;
  result = shadow_add_interface(driver);
  printk ("Added shadow interface to mops with result %d.\n", result);
  if (result >= 0) {
    driver->shadow_operations->smops = &shadow_mops;
    driver->iwrapper_operations.mops->init.wrapped = shadow_mops.init;
    driver->iwrapper_operations.mops->exit.wrapped = shadow_mops.cleanup;
  //  driver->iwrapper_operations.mops->can_unload.wrapped = shadow_mops.can_unload;
    driver->shadow_kernel_operations->sknetops = &shadow_sknetops;
  } else {
    if (result == -EINVAL) {
      result = 0; // no shadow running
    }
  }
  return result;
}

void shadow_del_smops(pnook_driver_t driver)
{
  shadow_del_interface(driver);
}



int sprocops_write_proc(struct file *file, const char *buffer, unsigned long count, void *data, int __driver_result, pnook_driver_t __driver)
{
  int result = __driver_result;
  shadow_log(__driver, __FUNCTION__, (int) __driver_result);
  return(result);
}

int sprocops_read_proc(char *page, char **start, off_t off, int count, int *eof, void *data, int __driver_result, pnook_driver_t __driver)
{
  int result = __driver_result;
  shadow_log(__driver, __FUNCTION__, (int) __driver_result);
  return(result);
}

int sprocops_get_info(char * arg0, char ** arg1, off_t arg2, int arg3, int __driver_result, pnook_driver_t __driver)
{
  int result = __driver_result;
  shadow_log(__driver, __FUNCTION__, (int) __driver_result);
  return(result);
}

struct sprocfs_operations shadow_procops = {
  write_proc: sprocops_write_proc,
  read_proc: sprocops_read_proc,
  get_info: sprocops_get_info
};

int shadow_add_sprocops(pnook_driver_t driver, void * arg)
{
  int result = 0;
  result = shadow_add_interface(driver);
  if (result >= 0) {
    driver->shadow_operations->sprocops = &shadow_procops;
    driver->iwrapper_operations.procops->write_proc.wrapped = shadow_procops.write_proc;
    driver->iwrapper_operations.procops->read_proc.wrapped = shadow_procops.read_proc;
    driver->iwrapper_operations.procops->get_info.wrapped = shadow_procops.get_info;
    driver->shadow_kernel_operations->sknetops = &shadow_sknetops;
  } else {
    if (result == -EINVAL) {
      result = 0; // no shadow running
    }
  }
  return result;
}

void shadow_del_sprocops(pnook_driver_t driver)
{
  shadow_del_interface(driver);
}
/*
int spciops_prepare(struct pci_dev *dev, int __driver_result, pnook_driver_t __driver)
{
  int result = __driver_result;
  shadow_log(__driver, __FUNCTION__, (int) __driver_result);
  return(result);
}
*/
void spciops_remove(struct pci_dev *dev, pnook_driver_t __driver)
{
  shadow_log(__driver, __FUNCTION__, 0);
  return;
}

void spciops_shutdown(struct pci_dev *dev, pnook_driver_t __driver)
{
  shadow_log(__driver, __FUNCTION__, 0);
  return;
}


int spciops_enable_wake(struct pci_dev *dev, u32 state, int enable, int __driver_result, pnook_driver_t __driver)
{
  int result = __driver_result;
  shadow_log(__driver, __FUNCTION__, (int) __driver_result);
  return(result);
}

int spciops_save_state(struct pci_dev *dev, u32 state, int __driver_result, pnook_driver_t __driver)
{
  int result = __driver_result;
  shadow_log(__driver, __FUNCTION__, (int) __driver_result);
  return(result);
}

/*
int spciops_activate(struct pci_dev *dev, int __driver_result, pnook_driver_t __driver)
{
  int result = __driver_result;
  shadow_log(__driver, __FUNCTION__, (int) __driver_result);
  return(result);
}
*/
int spciops_resume(struct pci_dev *dev, int __driver_result, pnook_driver_t __driver)
{
  int result = __driver_result;
  shadow_log(__driver, __FUNCTION__, (int) __driver_result);
  return(result);
}

int spciops_suspend(struct pci_dev *dev, u32 state, int __driver_result, pnook_driver_t __driver)
{
  int result = __driver_result;
  shadow_log(__driver, __FUNCTION__, (int) __driver_result);
  return(result);
}
/*
int spciops_deactivate(struct pci_dev *dev, int __driver_result, pnook_driver_t __driver)
{
  int result = __driver_result;
  shadow_log(__driver, __FUNCTION__, (int) __driver_result);
  return(result);
}
*/
int shadow_add_spciops(pnook_driver_t driver, void * arg)
{
  int result = 0;
  result = shadow_add_interface(driver);
  if (result >= 0) {
    driver->shadow_operations->spciops = &shadow_pciops;
    //driver->iwrapper_operations.pciops->prepare.wrapped = shadow_pciops.prepare;
    driver->iwrapper_operations.pciops->remove.wrapped = shadow_pciops.remove;
    driver->iwrapper_operations.pciops->enable_wake.wrapped = shadow_pciops.enable_wake;
    //driver->iwrapper_operations.pciops->save_state.wrapped = shadow_pciops.save_state;
    //driver->iwrapper_operations.pciops->activate.wrapped = shadow_pciops.activate;
    driver->iwrapper_operations.pciops->shutdown.wrapped = shadow_pciops.shutdown;
    driver->iwrapper_operations.pciops->resume.wrapped = shadow_pciops.resume;
    driver->iwrapper_operations.pciops->suspend.wrapped = shadow_pciops.suspend;
    //driver->iwrapper_operations.pciops->deactivate.wrapped = shadow_pciops.deactivate;
    driver->iwrapper_operations.pciops->probe.wrapped = shadow_pciops.probe;
    driver->shadow_kernel_operations->sknetops = &shadow_sknetops;
  } else {
    if (result == -EINVAL) {
      result = 0; // no shadow running
    }
  }
  return result;
}

void shadow_del_spciops(pnook_driver_t driver)
{
  shadow_del_interface(driver);
}

int snotifierops_notifier_call(struct notifier_block *self, unsigned long arg0, void * arg1, int __driver_result, pnook_driver_t __driver)
{
  int result = __driver_result;
  shadow_log(__driver, __FUNCTION__, (int) __driver_result);
  return(result);
}

struct snotifier_operations shadow_notifierops = {
  notifier_call: snotifierops_notifier_call
};

int shadow_add_snotifierops(pnook_driver_t driver, void * arg)
{
  int result = 0;
  result = shadow_add_interface(driver);
  if (result >= 0) {
    driver->shadow_operations->snotifierops = &shadow_notifierops;
    driver->iwrapper_operations.notifierops->notifier_call.wrapped = shadow_notifierops.notifier_call;
    driver->shadow_kernel_operations->sknetops = &shadow_sknetops;
  } else {
    if (result == -EINVAL) {
      result = 0; // no shadow running
    }
  }
  return result;
}

void shadow_del_snotifierops(pnook_driver_t driver)
{
  shadow_del_interface(driver);
}

int scallbackops_handler(unsigned long arg, int __driver_result, pnook_driver_t __driver)
{
  int result = __driver_result;
  shadow_log(__driver, __FUNCTION__, (int) __driver_result);
  return(result);
}

int scallbackops_pm_handler(struct pm_dev *dev, pm_request_t rqst, void *data, int __driver_result, pnook_driver_t __driver)
{
  int result = __driver_result;
  shadow_log(__driver, __FUNCTION__, (int) __driver_result);
  return(result);
}

struct scallback_operations shadow_callbackops = {
  handler: scallbackops_handler,
  pm_handler: scallbackops_pm_handler
};

int shadow_add_scallbackops(pnook_driver_t driver, void * arg)
{
  int result = 0;
  result = shadow_add_interface(driver);
  if (result >= 0) {
    driver->shadow_operations->scallbackops = &shadow_callbackops;
    driver->iwrapper_operations.callbackops->handler.wrapped = shadow_callbackops.handler;
    driver->iwrapper_operations.callbackops->pm_handler.wrapped = shadow_callbackops.pm_handler;
    driver->shadow_kernel_operations->sknetops = &shadow_sknetops;
  } else {
    if (result == -EINVAL) {
      result = 0; // no shadow running
    }
  }
  return result;
}

void shadow_del_scallbackops(pnook_driver_t driver)
{
  shadow_del_interface(driver);
}

void stimerops_handler(unsigned long arg, pnook_driver_t __driver)
{
  shadow_log(__driver, __FUNCTION__, 0);
  return;
}

struct stimer_operations shadow_timerops = {
  handler: stimerops_handler
};

int shadow_add_stimerops(pnook_driver_t driver, void * arg)
{
  int result = 0;
  result = shadow_add_interface(driver);
  if (result >= 0) {
    driver->shadow_operations->stimerops = &shadow_timerops;
    driver->iwrapper_operations.timerops->handler.wrapped = shadow_timerops.handler;
    driver->shadow_kernel_operations->sknetops = &shadow_sknetops;
  } else {
    if (result == -EINVAL) {
      result = 0; // no shadow running
    }
  }
  return result;
}

void shadow_del_stimerops(pnook_driver_t driver)
{
  shadow_del_interface(driver);
}

int ssysctlops_strategy(ctl_table *table, int *name, int nlen, void *oldval, size_t *oldlenp, void *newval, size_t newlen, void **context, int __driver_result, pnook_driver_t __driver)
{
  int result = __driver_result;
  shadow_log(__driver, __FUNCTION__, (int) __driver_result);
  return(result);
}

int ssysctlops_proc_handler(ctl_table *ctl, int write, struct file * filp, void *buffer, size_t *lenp, loff_t *ppos, int __driver_result, pnook_driver_t __driver)
{
  int result = __driver_result;
  shadow_log(__driver, __FUNCTION__, (int) __driver_result);
  return(result);
}

struct ssysctl_operations shadow_sysctlops = {
  strategy: ssysctlops_strategy,
  proc_handler: ssysctlops_proc_handler
};

int shadow_add_ssysctlops(pnook_driver_t driver, void * arg)
{
  int result = 0;
  result = shadow_add_interface(driver);
  if (result >= 0) {
    driver->shadow_operations->ssysctlops = &shadow_sysctlops;
    driver->iwrapper_operations.sysctlops->strategy.wrapped = shadow_sysctlops.strategy;
    driver->iwrapper_operations.sysctlops->proc_handler.wrapped = shadow_sysctlops.proc_handler;
    driver->shadow_kernel_operations->sknetops = &shadow_sknetops;
  } else {
    if (result == -EINVAL) {
      result = 0; // no shadow running
    }
  }
  return result;
}

void shadow_del_ssysctlops(pnook_driver_t driver)
{
  shadow_del_interface(driver);
}

void sirqops_handler(int irq, void * dev_id, struct pt_regs * regs, pnook_driver_t __driver)
{
  shadow_log(__driver, __FUNCTION__, 0);
  return;
}

struct sirq_operations shadow_irqops = {
  handler: sirqops_handler
};

int shadow_add_sirqops(pnook_driver_t driver, void * arg)
{
  int result = 0;
  result = shadow_add_interface(driver);
  if (result >= 0) {
    driver->shadow_operations->sirqops = &shadow_irqops;
    driver->iwrapper_operations.irqops->handler.wrapped = shadow_irqops.handler;
    driver->shadow_kernel_operations->sknetops = &shadow_sknetops;
  } else {
    if (result == -EINVAL) {
      result = 0; // no shadow running
    }
  }
  return result;
}

void shadow_del_sirqops(pnook_driver_t driver)
{
  shadow_del_interface(driver);
}

#endif // CONFIG_NOOKS_SHADOW
